
// wac 13 April 2016

#include "Adafruit_GFX_AS.h"    // Core graphics library
#include "Adafruit_ILI9341_AS.h" // Hardware-specific library
#include "SPI.h"

// These are the pins used for the UNO
// for Due/Mega/Leonardo use the hardware SPI pins (which are different)
#define _sck 13
#define _miso 12 // Not needed
#define _mosi 11
#define _cs 10
#define _dc_rs 9
#define _reset 7

Adafruit_ILI9341_AS tft = Adafruit_ILI9341_AS(_cs, _dc_rs, _reset);

boolean newData = false;
int loco = 0, fd, fl, f1, f2, f3,f4, f5, f6, f7, f8, Speed, function, e_stop, A;
String  inString;

    
void setup() {
  Serial.begin(9600);
  tft.init();
  tft.setRotation(3);
  tft.fillScreen(ILI9341_BLUE);
  tft.setTextColor(ILI9341_WHITE);
  tft.drawString("DCC Command Station 13 Apr 2016",10,15,2);
delay(200);
 
}
void loop(){
      recvdata();
  if (newData == true){
      showNewData(); 
    }
}
          
 void recvdata() {  
  newData = false;     
  char endmark = '\n';
  char rc;
  inString ="";
  delay(50);
    while (Serial.available() > 0 && newData == false) {
    rc = (char)Serial.read();
    inString += rc;
    
    if (rc == endmark && inString.length() >= 2) {
      Serial.print(inString); // to debug received data
      delay(50);
      newData = true;}
  }
 }

void showNewData() {
if (inString.startsWith("L")){
  inString = inString.substring(1);
  loco = inString.toInt();
     }
if (inString.startsWith("M")){
  inString = inString.substring(1);
  fd = inString.toInt();
     }
if (inString.startsWith("N")){
  inString = inString.substring(1);
  fl = inString.toInt();
     }
if (inString.startsWith("O")){
  inString = inString.substring(1);
  f1 = inString.toInt();
     }
if (inString.startsWith("P")){
  inString = inString.substring(1);
  f2 = inString.toInt();
     } 
if (inString.startsWith("Q")){
  inString = inString.substring(1);
  f3 = inString.toInt();
     } 
if (inString.startsWith("R")){
  inString = inString.substring(1);
  f4 = inString.toInt();
     } 
if (inString.startsWith("S")){
  inString = inString.substring(1);
  f5 = inString.toInt();
     } 
if (inString.startsWith("T")){
  inString = inString.substring(1);
  f6 = inString.toInt();
     } 
if (inString.startsWith("U")){
  inString = inString.substring(1);
  f7 = inString.toInt();
     } 
if (inString.startsWith("V")){
  inString = inString.substring(1);
  f8 = inString.toInt();
     } 
if (inString.startsWith("W")){
  inString = inString.substring(1);
  Speed = inString.toInt();
     } 
if (inString.startsWith("X")){
  inString = inString.substring(1);
  function = inString.toInt();
  if (function == 0) {
  display1();
  display4();}
  if (function == 1) {
  display2();
  display4();}
  if (function == 3 || function == 4) {
  display5();
  display4();}
  }
if (inString.startsWith("Y")){
  inString = inString.substring(1);
  e_stop = inString.toInt();
  if (e_stop == 1) {
  display3();}
     } 
  if (inString.startsWith("Z")){
  inString = inString.substring(1);
  A = inString.toInt();
     } 
  newData = false;
}

 void display1() { 
         tft.fillScreen(ILI9341_BLUE);
         tft.setTextColor(ILI9341_WHITE);
         tft.setTextSize(2);
         tft.setCursor(10, 30);
         tft.println("THROTTLE  MODE");
         delay(50);
  }
void display2() { 
         tft.fillScreen(ILI9341_BLACK);
         tft.setTextColor(ILI9341_WHITE);
         tft.setTextSize(2);
         tft.setCursor(10, 30);
         tft.println("FUNCTION  MODE");
         delay(50);
  }
void display3() { 
         tft.fillScreen(ILI9341_RED);
         tft.setTextColor(ILI9341_WHITE);
         tft.setTextSize(2);
         tft.setCursor(10, 100);
         tft.println("EMERGENCY  STOP");
         delay(50);
  }
void display4(){     
         tft.setTextSize(2);
         tft.setTextColor(ILI9341_WHITE);
         if (function <= 2){
         tft.setCursor(10, 70);
         tft.print("Loco :");
         tft.setCursor(80, 70);
         tft.print(loco);
         tft.setCursor(120, 70);
         tft.print("Dir :");
         tft.setCursor(170, 70);
         tft.print(fd);
         tft.setCursor(200, 70);
         tft.print("FL :");
         tft.setCursor(250, 70);
         tft.print(fl);
         } 
         if (function == 3 ){
          tft.setCursor(10, 90);
          tft.setTextColor(ILI9341_BLACK);
          tft.print("1  2  3  4  5  6  7  8 ");
          tft.setCursor(10, 120);
          tft.setTextColor(ILI9341_RED);
          tft.print("T1 2  3  4  5  6  7  8");
          tft.setTextColor(ILI9341_BLACK);
          }
         if (function == 4){
          tft.setCursor(10, 90);
          tft.setTextColor(ILI9341_BLACK);
          tft.print("1  2  3  4  5  6  7  8 ");
          tft.setCursor(10, 120);
          tft.setTextColor(ILI9341_RED);
          tft.print("T9 10 11 12 13 14 15 16");
          tft.setTextColor(ILI9341_BLACK);
          }
          if (function <= 2){
            tft.setCursor(10, 120);
            tft.setTextColor(ILI9341_WHITE);
            tft.print("F1 F2 F3 F4 F5 F6 F7 F8");
            }
         tft.setCursor(10, 150);
         tft.print(f1);
         tft.setCursor(45, 150);
         tft.print(f2);
         tft.setCursor(80, 150);
         tft.print(f3);
         tft.setCursor(115, 150);
         tft.print(f4);
         tft.setCursor(150, 150);
         tft.print(f5);
         tft.setCursor(185, 150);
         tft.print(f6);
         tft.setCursor(220, 150);
         tft.print(f7);
         tft.setCursor(255, 150);
         tft.print(f8);
         if (function <= 2){
         tft.setCursor(10, 190);
         tft.print("Speed :");
         tft.setCursor(100, 190);
         tft.print(Speed);
         tft.setCursor(160, 190);
         tft.print("mA :");
         tft.setCursor(215, 190);
         tft.print(A);
         }
}
void display5() { 
         tft.fillScreen(ILI9341_GREEN);
         tft.setTextColor(ILI9341_BLACK);
         tft.setTextSize(2);
         tft.setCursor(10, 30);
         if (function == 3){
         tft.println("TURNOUTS 1 to 8");}
         if (function == 4){
         tft.println("TURNOUTS 9 to 16");}
         delay(50);
  }
