

// wac 30 May 2017   changed DCC digital output switching to increase spped;
// amended 27 Feb 2018 ; added void 'set_fun' ; added to 'get_key' if (last_locoAdr != locoAdr && locoAdr > 0){set_fun();}
// added SoftwareSerial and new current sense void 10 July 2018
#include <SoftwareSerial.h>
SoftwareSerial dcc(A3,A4);  // RX TX

#include "Keypad.h"
const byte ROWS = 4; //four rows
const byte COLS = 4; //four columns 
char keys[ROWS][COLS] = {
  {'1','2','3', 'A'},
  {'4','5','6', 'B'},
  {'7','8','9', 'C'},
  {'*','0','#', 'D'}
};
byte rowPins[ROWS] = {2,3,4,5}; //connect to the row pinouts of the keypad
byte colPins[COLS] = {6,7,8,11}; //connect to the column pinouts of the keypad

Keypad keypad = Keypad( makeKeymap(keys), rowPins, colPins, ROWS, COLS );
char key = keypad.getKey();



#define DCC_PIN    10  // Arduino pin for DCC out 
                      // this pin is connected to "DIRECTION" of LMD18200
#define DCC_PWM    9  // must be HIGH for signal out
                      // connected to "PWM in" of LMD18200
#define AN_SPEED   7  // analog reading for Speed Poti

#define AN_CURRENT    0  // A0 analog reading for current sense


//Timer frequency is 2MHz for ( /8 prescale from 16MHz )
#define TIMER_SHORT 0x8D  // 58usec pulse length 
#define TIMER_LONG  0x1B  // 116usec pulse length 

unsigned char last_timer=TIMER_SHORT;  // store last timer value
   
unsigned char flag=0;  // used for short or long pulse
unsigned char every_second_isr = 0;  // pulse up or down

// definitions for state machine 
#define PREAMBLE 0    
#define SEPERATOR 1
#define SENDBYTE  2

unsigned char state= PREAMBLE;
unsigned char preamble_count = 16;
unsigned char outbyte = 0;
unsigned char cbit = 0x80;
boolean get_locospeed = false;
boolean get_function = false;
boolean get_turnout = false;

// variables for throttle / functions
int locoSpeed = 0;
int last_locoSpeed = 0;
int dir = 0;
int fl = 0;
int fun1 = 0;int fun2 = 0;int fun3 = 0;int fun4 = 0;int fun5 = 0;int fun6 = 0;int fun7 = 0;int fun8 = 0;  // functions
int tun1 = 0;int tun2 = 0;int tun3 = 0;int tun4 = 0;int tun5 = 0;int tun6 = 0;int tun7 = 0;int tun8 = 0;  // turnouts
int tun9 = 0;int tun10 = 0;int tun11 = 0;int tun12 = 0;int tun13 = 0;int tun14 = 0;int tun15 = 0;int tun16 = 0;  // turnouts
int teen = 0;
int last_locoAdr = 0;
int key_val;
int function = 0;
int last_function = 0;
int e_stop = 0;
int last_e_stop = 0;
unsigned char  data = 0, xdata;
float A;
int turn_a = 0;
int turn_b = 0;
int last_turn_a = 0;
int last_turn_b = 0;
int turnAddr = 1;
int maxF =4;
int locoAdr = 9;   // this is the default address of the loco
int sensorValue;

// buffer for command
struct Message {
   unsigned char data[7];
   unsigned char len;
} ;

#define MAXMSG 3
// for the time being, use only 2 messages - the idle msg, the loco Speed msg, function msg

struct Message msg[MAXMSG] = { 
    { { 0xFF,     0, 0xFF, 0, 0, 0, 0}, 3},   // idle msg
    { { locoAdr, 0, 0,  0, 0, 0, 0}, 4}   // locoMsg with 128 speed steps 0x3f
  };               // loco msg must be filled later with speed and XOR data byte
                                
int msgIndex=0;  
int byteIndex=0;

int la[20];// array to hold loco numbers
int sa[20];// array to hold speed values
int fda[20];// array to hold dir
int fla[20];// array to hold lights
int f1a[20];// array to hold fun1
int f2a[20];// array to hold fun2
int f3a[20];// array to hold fun3
int f4a[20];// array to hold fun4
int f5a[20];// array to hold fun5
int f6a[20];// array to hold fun6
int f7a[20];// array to hold fun7
int f8a[20];// array to hold fun8

int tun[20];// array to hold turnout values

//Setup Timer2.
//Configures the 8-Bit Timer2 to generate an interrupt at the specified frequency.
//Returns the time load value which must be loaded into TCNT2 inside your ISR routine.

void SetupTimer2(){
  DDRB = B00000110;   //  register B for digital pin 9 and pin 10
  //Timer2 Settings: Timer Prescaler /8, mode 0
  //Timmer clock = 16MHz/8 = 2MHz oder 0,5usec
  TCCR2A = 0;
  TCCR2B = 0<<CS22 | 1<<CS21 | 0<<CS20; 

  //Timer2 Overflow Interrupt Enable   
  TIMSK2 = 1<<TOIE2;

  //load the timer for its first cycle
  TCNT2=TIMER_SHORT; 
}
//Timer2 overflow interrupt vector handler
ISR(TIMER2_OVF_vect) {
  //Capture the current timer value TCTN2. This is how much error we have
  //due to interrupt latency and the work in this function
  //Reload the timer and correct for latency.  
  // for more info, see http://www.uchobby.com/index.php/2007/11/24/arduino-interrupts/
  unsigned char latency;
  // for every second interupt just toggle signal
  if (every_second_isr)  {
    PORTB = B00000110;   // using register control to speed up switching speed  pin 9 kept HIGH (PWM),  pin 10 switched HIGH (DIR)
     every_second_isr = 0;        
     // set timer to last value
     latency=TCNT2;
     TCNT2=latency+last_timer;  
  }  else  {  // != every second interrupt, advance bit or state
     PORTB = B00000010;  // pin 9 kept HIGH ,  pin 10 switched LOW
     every_second_isr = 1; 
     switch(state)  {
       case PREAMBLE:
           flag=1; // short pulse
           preamble_count--;
           if (preamble_count == 0)  {  // advance to next state
              state = SEPERATOR;
              // get next message
              msgIndex++;
              if (msgIndex >= MAXMSG)  {  msgIndex = 0; }  
              byteIndex = 0; //start msg with byte 0
           }
           break;
        case SEPERATOR:
           flag=0; // long pulse
           // then advance to next state
           state = SENDBYTE;
           // goto next byte ...
           cbit = 0x80;  // send this bit next time first         
           outbyte = msg[msgIndex].data[byteIndex];
           break;
        case SENDBYTE:
           if (outbyte & cbit)  { 
              flag = 1;  // send short pulse
           }  else  {
              flag = 0;  // send long pulse
           }
           cbit = cbit >> 1;
           if (cbit == 0)  {  // last bit sent, is there a next byte?
              byteIndex++;
              if (byteIndex >= msg[msgIndex].len)  {
                 // this was already the XOR byte then advance to preamble
                 state = PREAMBLE;
                 preamble_count = 16;
              }  else  {
                 // send separtor and advance to next byte
                 state = SEPERATOR ;
              }
           }
           break;
     }   
     if (flag)  {  // if data==1 then short pulse
        latency=TCNT2;
        TCNT2=latency+TIMER_SHORT;
        last_timer=TIMER_SHORT;
     }  else  {   // long pulse
        latency=TCNT2;
        TCNT2=latency+TIMER_LONG; 
        last_timer=TIMER_LONG;
     }  
  }
}

void setup() {
   dcc.begin(9600);
   Serial.begin(9600);
  //zero array
  for (int i = 0 ; i<=20 ; i++){
  la[i] = i; 
  sa[i] = 0;
  fda[i] = 0;
  fla[i] = 0;
  f1a[i] = 0;
  f2a[i] = 0;
  f3a[i] = 0;
  f4a[i] = 0;
  f5a[i] = 0;
  f6a[i] = 0;
  f7a[i] = 0;
  f8a[i] = 0;
  
  tun[i] = 0;
 }
  //Set the pins for DCC to "output".
  pinMode(DCC_PIN,OUTPUT);   // this is for the DCC Signal
  pinMode(DCC_PWM,OUTPUT);   // will be kept high, PWM pin
  digitalWrite(DCC_PWM,1);
  read_locoSpeed();
  amend_len4(msg[1]);
  assemble_dcc_msg_speed();
  //Start the timer 
  SetupTimer2();   
}

void amend_speed (struct Message & x) 
{ 
 x.data[0] = locoAdr;
 x.data[1] = 0x3f;  // locoMsg with 128 speed steps 0x3f
}

void amend_group1 (struct Message & x) 
{ 
 x.data[0] = locoAdr;
 x.data[1] = 0x80;   // locoMsg with group one instruction 0x80
 x.data[3] = 0;
}

void amend_tun1 (struct Message & x) 
{ 
 x.data[0] = 0x81; // accessory decoder 0x80 & address 1
 x.data[1] = 0;
 x.data[3] = 0;
}

void amend_tun2 (struct Message & x) 
{ 
 x.data[0] = 0x82; // accessory decoder 0x80 & address 2
 x.data[1] = 0;
 x.data[3] = 0;
}

void amend_tun3 (struct Message & x) 
{ 
 x.data[0] = 0x83; // accessory decoder 0x83 & address 3
 x.data[1] = 0;
 x.data[3] = 0;
}

void amend_tun4 (struct Message & x) 
{ 
 x.data[0] = 0x84; // accessory decoder 0x84 & address 4
 x.data[1] = 0;
 x.data[3] = 0;
}

 void amend_len4 (struct Message & x) 
{ 
 x.len = 4;
   //Serial.println(x.len);
}

void amend_len3 (struct Message & x) 
{ 
 x.len = 3;
  //Serial.println(x.len);
}

void current(){
  sensorValue = analogRead(AN_CURRENT);
  // Convert the analog reading (which goes from 0 - 1023) to a voltage (0 - 5V) = 4.9mv per division
  // 0.1 ohm resistor on current sense gives 200mv at 2 Amps or, 100mv per Amp
  // 100/4.9 = 20 divisions per Amp or 20 divisions per 1000mA or 1 division = 50mA
      A = 50 * sensorValue ;  // mA
    //Serial.println(sensorValue);
    //Serial.print("Current (mA) = ");
   // Serial.println(A);
}

void loop(void) {   
  delay(20);
  current();
   if (read_locoSpeed() && turn_a ==0 && turn_b ==0)  {
       assemble_dcc_msg_speed();
       delay(20);
       send_data();
  }
  if (read_function() && turn_a == 0 && turn_b == 0)  {
       assemble_dcc_msg_group1(); 
       send_data();
  }
  if (read_turnout()){
       assemble_dcc_msg_tun(); 
      
       if (turn_a == 1) { 
       send_turnout_a();
       }
       if (turn_b == 1) { 
       send_turnout_b();
       }
       //send_data3();
  }
       //send_data3();
}


boolean read_locoSpeed()  {
   delay(20);
   boolean changed_l = false;
   data = 0;
   get_key();
  if (last_e_stop != e_stop){
      last_e_stop = e_stop;
   if (e_stop == 1){// emergency stop
        data |= 1;
        locoAdr = 0;
        turn_a = 0;
        turn_b = 0;
        changed_l = true;
        amend_speed(msg[1]);
        return changed_l;
        }
   if (e_stop == 0){// remove emergency stop
         locoAdr = last_locoAdr;
         digitalWrite(DCC_PWM,1);
         send_data();
        }
       }
  if (A > 2000){  // current limit
        e_stop = 1;
        data |= 1;
        locoAdr = 0;
        changed_l = true;
        amend_speed(msg[1]);
        digitalWrite(DCC_PWM,0);
        return changed_l;
        }
   if (last_locoAdr != locoAdr && locoAdr > 0){
    changed_l = true;
    last_locoAdr = locoAdr;
    locoSpeed = sa[locoAdr];
    } 
   if (fda[locoAdr] != dir){
    changed_l = true;
    fda[locoAdr] = dir;
    }
   if (fda[locoAdr] == 0){
       data = 0;
    }
    if (fda[locoAdr] == 1){
       data = 0x80;
    } 
       
 if (locoAdr > 0){  
    locoSpeed = (127L * analogRead(AN_SPEED))/1023;
   if (last_locoSpeed < locoSpeed -1 || last_locoSpeed > locoSpeed +1) {
      last_locoSpeed = locoSpeed;
      changed_l = true; 
      sa[locoAdr] = locoSpeed;
       }
       }
    data |= sa[locoAdr];
    amend_speed(msg[1]);
    return changed_l;
}
 void set_fun(){
    dir = fda[locoAdr];
    fl = fla[locoAdr];
    fun1 = f1a[locoAdr];
    fun2 = f2a[locoAdr];
    fun3 = f3a[locoAdr];
    fun4 = f4a[locoAdr];
    fun5 = f5a[locoAdr];
    fun6 = f6a[locoAdr];
    fun7 = f7a[locoAdr];
    fun8 = f8a[locoAdr];  
 }
 
boolean read_function()  {
   delay(20);
   boolean changed_f = false; 
   get_key();  
   amend_group1(msg[1]); 
   
 if (fla[locoAdr]  != fl){
    fla[locoAdr] = fl;
    changed_f = true;
   }
 if (fla[locoAdr] == 0) {
    data = 0x80;
   } //head lights off
   
 if (fla[locoAdr] == 1) {
    data = 0x90;
   } //head lights on
  //Serial.println(fla[locoAdr]);
  //Serial.println(data, HEX);
if (last_function != function){
    last_function = function;
    send_data();
   }

 
    if (f1a[locoAdr] != fun1){
    f1a[locoAdr] = fun1;
    changed_f = true;
    }
    if (f1a[locoAdr] == 0) {
    data |= 0;  // f1 off
    }
    if (f1a[locoAdr] == 1) {
    data |= 0x01; // f1 on
    }
    if (f2a[locoAdr] != fun2){
    f2a[locoAdr] = fun2;
    changed_f = true;
    }
    if (f2a[locoAdr] == 0) {
    data |= 0;
    }
    if (f2a[locoAdr] == 1) {
    data |= 0x02; // f2  on
    }
    if (f3a[locoAdr] != fun3){
    f3a[locoAdr] = fun3;
    changed_f = true;
    }
    if (f3a[locoAdr] == 0) {
    data |= 0;  
    }
    if (f3a[locoAdr] == 1) {
    data |= 0x04; // f3  on
    }
    if (f4a[locoAdr] != fun4){
    f4a[locoAdr] = fun4;
    changed_f = true;
    }
    if (f4a[locoAdr] == 0) {
    data |= 0;
    }
    if (f4a[locoAdr] == 1) {
    data |= 0x08; // f4  on
    }

 if (key_val >= 500 && key_val <= 800){
    data = 0xB0;                  // locoMsg with group two instruction
    if (f5a[locoAdr] != fun5){
    f5a[locoAdr] = fun5;
    changed_f = true;
    }
    if (f5a[locoAdr] == 0) {
    data |= 0;
    }
    if (f5a[locoAdr] == 1) {
    data |= 0x01; // f5  on
    }
    if (f6a[locoAdr] != fun6){
    f6a[locoAdr] = fun6;
    changed_f = true;
    }
    if (f6a[locoAdr] == 0) {
    data |= 0;
    }
    if (f6a[locoAdr] == 1) {
    data |= 0x02; // f6  on
    }
    if (f7a[locoAdr] != fun7){
    f7a[locoAdr] = fun7;
    changed_f = true;
    }
    if (f7a[locoAdr] == 0) {
    data |= 0;
    }
    if (f7a[locoAdr] == 1) {
    data |= 0x04; // f7  on
    }
    if (f8a[locoAdr] != fun8){
    f8a[locoAdr] = fun8;
    changed_f = true;
    }
    if (f8a[locoAdr] == 0) {
    data |= 0;
    }
    if (f8a[locoAdr] == 1) {
    data |= 0x08; // f8  on
    } 
  }
    return changed_f;
}
boolean read_turnout()  {
   delay(20);
   boolean changed_t = false; 
   
   get_key();  

   
  if (key_val >= 101 && key_val <= 404 && turn_a == 1){
    data = 0xf8;
    amend_tun1(msg[1]);
  }
  if (key_val >= 505 && key_val <= 808 && turn_a == 1){
    data = 0xf8;
    amend_tun2(msg[1]);
  }
  if (key_val >= 101 && key_val <= 404 && turn_b == 1){
    data = 0xf8;
    amend_tun3(msg[1]);
  }
  if (key_val >= 505 && key_val <= 808 && turn_b == 1){
    data = 0xf8;
    amend_tun4(msg[1]);
  }
  
    if (tun[1] != tun1){
    tun[1] = tun1;
    changed_t = true;
    }
    if (key_val == 101 && turn_a == 1){
     if (tun1 == 1 ){
     data |= 0; // t1 
     }
     if (tun1 == 0 ){
     data |= 0x01; // t1
     } 
    }

   if (tun[2] != tun2){
    tun[2] = tun2;
    changed_t = true;
    }
    if (key_val == 202 && turn_a == 1){
     if (tun2 == 1 ){
     data |= 0x02; // t2 
    }
    if (tun2 == 0 ){
    data |= 0x03 ; // t2 
    }
    }

    if (tun[3] != tun3){
    tun[3] = tun3;
    changed_t = true;
    }
    if (key_val == 303 && turn_a == 1){
    if (tun3 == 1 ){
    data |= 0x04;  // t3  
    }
    if (tun3 == 0 ){
    data |= 0x05;  // t3  
    } 
    }

    if (tun[4] != tun4){
    tun[4] = tun4;
    changed_t = true;
    }
    if (key_val == 404 && turn_a == 1){
    if (tun4 == 1 ){
    data |= 0x06;  // t4  
    }
    if (tun4 == 0 ){
    data |= 0x07; // f4  
    }
    }

    if (tun[5] != tun5){
    tun[5] = tun5;
    changed_t = true;
    }
    if (key_val == 505 && turn_a == 1){
    if (tun5 == 1 ){
    data |= 0; // t5 
    }
    if (tun5 == 0 ){
    data |= 0x01; // t5 
    }
    }

    if (tun[6] != tun6){
    tun[6] = tun6;
    changed_t = true;
    }
    if (key_val == 606 && turn_a == 1){
    if (tun6 == 1 ){
    data |= 0x02; // t6 
    }
    if (tun6 == 0 ){
    data |= 0x03; // t6
    }
    }

    if (tun[7] != tun7){
    tun[7] = tun7;
    changed_t = true;
    }
    if (key_val == 707 && turn_a == 1){
    if (tun7 == 1 ){
    data |= 0x04; // t7 
    }
    if (tun7 == 0 ){
    data |= 0x05; // t7 
    }
    }

    if (tun[8] != tun8){
    tun[8] = tun8;
    changed_t = true;
    }
    if (key_val == 808 && turn_a == 1){
    if (tun8 == 1 ){
    data |= 0x06; // t8 
    }
    if (tun8 == 0 ){
    data |= 0x07; // t8 
    }
    }

   if (tun[9] != tun9){
    tun[9] = tun9;
    changed_t = true;
    }
   if (key_val == 101 && turn_b == 1){
    if (tun9 == 1 ){
    data |= 0; // t9 
    }
    if (tun9 == 0 ){
    data |= 0x01; // t9 
    }
    }

    if (tun[10] != tun10){
    tun[10] = tun10;
    changed_t = true;
    }
    if (key_val == 202 && turn_b == 1){
    if (tun10 == 1 ){
    data |= 0x02; // t10 
    }
    if (tun10 == 0 ){
    data |= 0x03; // t10 
    }
    }

    if (tun[11] != tun11){
    tun[11] = tun11;
    changed_t = true;
    }
    if (key_val == 303 && turn_b == 1){
    if (tun11 == 1 ){
    data |= 0x04; // t11 
    }
    if (tun11 == 0 ){
    data |= 0x05; // t11 
    }
    }

    if (tun[12] != tun12){
    tun[12] = tun12;
    changed_t = true;
    }
    if (key_val == 404 && turn_b == 1){
    if (tun12 == 1 ){
    data |= 0x06; // t12 
    }
    if (tun12 == 0 ){
    data |= 0x07; // t12 
    }
    }

    if (tun[13] != tun13){
    tun[13] = tun13;
    changed_t = true;
    }
    if (key_val == 505 && turn_b == 1){
    if (tun13 == 1 ){
    data |= 0; // t13 
    }
    if (tun13 == 0 ){
    data |= 0x01; // t13 
    }
    }

    if (tun[14] != tun14){
    tun[14] = tun14;
    changed_t = true;
    }
    if (key_val == 606 && turn_b == 1){
    if (tun14 == 1 ){
    data |= 0x02; // t14 
    }
    if (tun14 == 0 ){
    data |= 0x03; // t14 
    }
    }

    if (tun[15] != tun15){
    tun[15] = tun15;
    changed_t = true;
    }
    if (key_val == 707 && turn_b == 1){
    if (tun15 == 1 ){
    data |= 0x04; // t15 
    }
    if (tun15 == 0 ){
    data |= 0x05; // t15 
    }
    }

    if (tun[16] != tun16){
    tun[16] = tun16;
    changed_t = true;
    }
    if (key_val == 808 && turn_b == 1){
    if (tun16 == 1 ){
    data |= 0x06; // t16 
    }
    if (tun16 == 0 ){
    data |= 0x07; // t16 
    }
    }
    return changed_t;
}

void assemble_dcc_msg_speed() {
   // add XOR byte 
   xdata = (msg[1].data[0] ^ msg[1].data[1]) ^ data;
   
   noInterrupts();  // make sure that only "matching" parts of the message are used in ISR
   msg[1].data[2] = data;
   msg[1].data[3] = xdata; 
   interrupts();
}

void assemble_dcc_msg_group1() {
   // add XOR byte 
   xdata = (msg[1].data[0] ^ data); 
   noInterrupts();  // make sure that only "matching" parts of the message are used in ISR
   msg[1].data[1] = data;
   msg[1].data[2] = xdata; 
   interrupts();
}

void assemble_dcc_msg_tun() {
   // add XOR byte 
   xdata = (msg[1].data[0] ^ data); 
   noInterrupts();  // make sure that only "matching" parts of the message are used in ISR
   msg[1].data[1] = data;
   msg[1].data[2] = xdata; 
   interrupts();
}

void get_key(){
  char key = keypad.getKey();
  if (key == NO_KEY){
    return;
  }
  delay(200);
   if (key != NO_KEY){
    //Serial.println(key);
    key_val = key - '0';
     if (key_val == -13){
     teen ^= 10;
     locoAdr = teen;
     locoAdr = constrain(locoAdr, 1, 10);
    }
    
     if (key_val == 17){
      turn_a = 0 ;
      turn_b = 0 ;
      function ^= 1;
    }
     if (key_val == 18){
      function = 0;
      turn_b = 0;
      turn_a = 1;
      send_turnout_a();
     
      }
      if (key_val == 19){
      function = 0;
      turn_a = 0;
      turn_b = 1;
      send_turnout_b();
     
      }
      
 if (key_val == 20){
     e_stop ^= 1;
    }
 if (key_val >= 1 && key_val <= 9 && function == 0 && turn_a == 0 && turn_b == 0){
      locoAdr = key_val + teen;
    }

 if (key_val == -6){
     dir ^= 1;
    }
 if (key_val == 0){
     fl ^= 1;
    }

 if (key_val >= 1 && key_val <= 9 && function == 1){
      key_val = key_val * 100;
    }
 if (key_val == 100 && function == 1){
     fun1 ^= 1;
    }
 if (key_val == 200 && function == 1){
     fun2 ^= 1;
    }
 if (key_val == 300 && function == 1){
     fun3 ^= 1;
    }
 if (key_val == 400 && function == 1){
     fun4 ^= 1;
    }
 if (key_val == 500 && function == 1){
     fun5 ^= 1;
    }
 if (key_val == 600 && function == 1){
     fun6 ^= 1;
    }
 if (key_val == 700 && function == 1){
     fun7 ^= 1;
    }
 if (key_val == 800 && function == 1){
     fun8 ^= 1;
    }

if (turn_a == 1){
 if (key_val >= 1 && key_val <= 9 ){
      key_val = key_val * 101;
    }
 if (key_val == 101){
     tun1 ^= 1;
    }
 if (key_val == 202){
     tun2 ^= 1;
    }
 if (key_val == 303){
     tun3 ^= 1;
    }
 if (key_val == 404){
     tun4 ^= 1;
    }
 if (key_val == 505){
     tun5 ^= 1;
    }
 if (key_val == 606){
     tun6 ^= 1;
    }
 if (key_val == 707){
     tun7 ^= 1;
    }
 if (key_val == 808){
     tun8 ^= 1;
    }
}

if (turn_b ==1){
 if (key_val >= 1 && key_val <= 9 ){
      key_val = key_val * 101;
    }
 if (key_val == 101){
     tun9 ^= 1;
    }
 if (key_val == 202){
     tun10 ^= 1;
    }
 if (key_val == 303){
     tun11 ^= 1;
    }
 if (key_val == 404){
     tun12 ^= 1;
    }
 if (key_val == 505){
     tun13 ^= 1;
    }
 if (key_val == 606){
     tun14 ^= 1;
    }
 if (key_val == 707){
     tun15 ^= 1;
    }
 if (key_val == 808){
     tun16 ^= 1;
    }
   }
   if (last_locoAdr != locoAdr && locoAdr > 0){
      set_fun();
    }
  }
}

void send_data(){
   dcc.print("L");
   dcc.println(locoAdr, DEC);
   dcc.print("M");
   dcc.println(fda[locoAdr], DEC);
   dcc.print("N");
   dcc.println(fla[locoAdr], DEC);
   dcc.print("O");
   dcc.println(f1a[locoAdr], DEC);
   dcc.print("P");
   dcc.println(f2a[locoAdr], DEC);
   dcc.print("Q");
   dcc.println(f3a[locoAdr], DEC);
   dcc.print("R");
   dcc.println(f4a[locoAdr], DEC);
   dcc.print("S");
   dcc.println(f5a[locoAdr], DEC);
   dcc.print("T");
   dcc.println(f6a[locoAdr], DEC);
   dcc.print("U");
   dcc.println(f7a[locoAdr], DEC);
   dcc.print("V");
   dcc.println(f8a[locoAdr], DEC);
   dcc.print("W");
   dcc.println(sa[locoAdr], DEC);
   dcc.print("X");
   dcc.println(function);
   dcc.print("Y");
   dcc.println(e_stop);
   dcc.print("Z");
   dcc.println(A);
   dcc.println("\n"); 
}

void send_turnout_a(){
   Serial.print("L");
   Serial.println(locoAdr, DEC);
   Serial.print("M");
   Serial.println(fda[locoAdr], DEC);
   Serial.print("N");
   Serial.println(fla[locoAdr], DEC);
   Serial.print("O");
   Serial.println(tun1, DEC);
   Serial.print("P");
   Serial.println(tun2, DEC);
   Serial.print("Q");
   Serial.println(tun3, DEC);
   Serial.print("R");
   Serial.println(tun4, DEC);
   Serial.print("S");
   Serial.println(tun5, DEC);
   Serial.print("T");
   Serial.println(tun6, DEC);
   Serial.print("U");
   Serial.println(tun7, DEC);
   Serial.print("V");
   Serial.println(tun8, DEC);
   Serial.print("W");
   Serial.println(sa[locoAdr], DEC);
   Serial.print("X");
   Serial.println("3");
   Serial.print("Y");
   Serial.println(e_stop);
   Serial.print("Z");
   Serial.println(A);
   Serial.println("\n"); 
}

void send_turnout_b(){
   Serial.print("L");
   Serial.println(locoAdr, DEC);
   Serial.print("M");
   Serial.println(fda[locoAdr], DEC);
   Serial.print("N");
   Serial.println(fla[locoAdr], DEC);
   Serial.print("O");
   Serial.println(tun9, DEC);
   Serial.print("P");
   Serial.println(tun10, DEC);
   Serial.print("Q");
   Serial.println(tun11, DEC);
   Serial.print("R");
   Serial.println(tun12, DEC);
   Serial.print("S");
   Serial.println(tun13, DEC);
   Serial.print("T");
   Serial.println(tun14, DEC);
   Serial.print("U");
   Serial.println(tun15, DEC);
   Serial.print("V");
   Serial.println(tun16, DEC);
   Serial.print("W");
   Serial.println(sa[locoAdr], DEC);
   Serial.print("X");
   Serial.println("4");
   Serial.print("Y");
   Serial.println(e_stop);
   Serial.print("Z");
   Serial.println(A);
   Serial.println("\n"); 
}

void send_data2(){
  for (int i = 1 ; i<=9 ; i++){
        Serial.print(la[i],DEC);
        Serial.print(" ");
        Serial.print(fda[i],DEC);
        Serial.print(" ");
        Serial.print(fla[i],DEC);
        Serial.print(" ");
        Serial.print(f1a[i],DEC);
        Serial.print(" ");
        Serial.print(f2a[i],DEC);
        Serial.print(" ");
        Serial.print(f3a[i],DEC);
        Serial.print(" ");
        Serial.print(f4a[i],DEC);
        Serial.print(" ");
        Serial.print(f5a[i],DEC);
        Serial.print(" ");
        Serial.print(f6a[i],DEC);
        Serial.print(" ");
        Serial.print(f7a[i],DEC);
        Serial.print(" ");
        Serial.print(f8a[i],DEC);
        Serial.print(" ");
        Serial.print(sa[i],DEC);
        Serial.print(" ");
        Serial.println(""); 
    }
}

void send_data3(){
   Serial.print("msg[1].data[0] ");
   Serial.print(msg[1].data[0], BIN);Serial.print(" , ");Serial.print(msg[1].data[0], HEX);Serial.print("\n");
   Serial.print("msg[1].data[1] ");
   Serial.print(msg[1].data[1], BIN);Serial.print(" , ");Serial.print(msg[1].data[1], HEX);Serial.print("\n");
   Serial.print("msg[1].data[2] ");
   Serial.print(msg[1].data[2], BIN); Serial.print(" , ");Serial.print(msg[1].data[2], HEX);Serial.print("\n");
   Serial.print("msg[1].data[3] ");
   Serial.print(msg[1].data[3], BIN);Serial.print(" , ");Serial.print(msg[1].data[3], HEX);Serial.print("\n");
   
}

